%define name		struts
%define full_name	jakarta-%{name}
%define version		1.0.2
%define release		4jpp
%define tomcat3appsdir	%{_localstatedir}/tomcat3/webapps
%define tomcat4appsdir	%{_localstatedir}/tomcat4/webapps
%define section		free
%define webapps		blank example template-example exercise-taglib upload

Name:		%{name}
Version:	%{version}
Release:	%{release}
Epoch:		0
Summary:	Web application framework
License:	Apache License
Source:		%{full_name}-%{version}-src.tar.gz
Patch:		%{name}.build.patch
Url:		http://jakarta.apache.org/%{name}
Requires:	servlet
Requires:	jdbc-stdext
BuildRequires:	ant
BuildRequires:	jaxp_transform_impl
BuildRequires:	servlet
BuildRequires:	jdbc-stdext
BuildRequires:	jpackage-utils > 1.4
Group:		Development/Java
Buildarch:	noarch
Buildroot:	%{_tmppath}/%{name}-%{version}-buildroot
Vendor:		JPackage project

%description
Welcome to the Struts Framework! The goal of this project is to provide
an open source framework useful in building web applications with Java
Servlet and JavaServer Pages (JSP) technology. Struts encourages
application architectures based on the Model-View-Controller (MVC)
design paradigm, colloquially known as Model 2 in discussions on various
servlet and JSP related mailing lists.
Struts includes the following primary areas of functionality:
A controller servlet that dispatches requests to appropriate Action
classes provided by the application developer.
JSP custom tag libraries, and associated support in the controller
servlet, that assists developers in creating interactive form-based
applications.
Utility classes to support XML parsing, automatic population of
JavaBeans properties based on the Java reflection APIs, and
internationalization of prompts and messages.
Struts is part of the Jakarta Project, sponsored by the Apache Software
Foundation. The official Struts home page is at
http://jakarta.apache.org/struts.

%package manual
Summary:        Manual for %{name}
Group:          Development/Java

%description manual
Documentation for %{name}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Java

%description javadoc
Javadoc for %{name}.

%package webapps-tomcat3
Summary:        Sample %{name} webapps for tomcat3
Group:          Development/Java
Requires:       %{name} = %{version}-%{release}
Requires:       tomcat3

%description webapps-tomcat3
Sample %{name} webapps for tomcat3.

%package webapps-tomcat4
Summary:        Sample %{name} webapps for tomcat4
Group:          Development/Java
Requires:       %{name} = %{version}-%{release}
Requires:       tomcat4

%description webapps-tomcat4
Sample %{name} webapps for tomcat4.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -n %{full_name}-%{version}-src
%patch
# remove all binary libs
find . -name "*.jar" -exec rm -f {} \;

%build
export CLASSPATH=$(build-classpath xml-commons-apis jaxp_parser_impl \
jaxp_transform_impl jdbc-stdext servlet)
ant -Djdbc20ext.jar=$(find-jar jdbc-stdext) compile.library compile.webapps compile.javadoc

%install
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 target/library/%{name}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done)
# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/documentation/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
rm -rf target/documentation/api
# data
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 target/library/*.tld $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 target/library/*.dtd $RPM_BUILD_ROOT%{_datadir}/%{name}
# tomcat 3 webapps
install -d -m 755 $RPM_BUILD_ROOT%{tomcat3appsdir}
for webapp in %{webapps}; do
    cp -pr target/$webapp $RPM_BUILD_ROOT%{tomcat3appsdir}/%{name}-$webapp
    (cd $RPM_BUILD_ROOT%{tomcat3appsdir}/%{name}-$webapp/WEB-INF/lib \
    && ln -sf ../../../../../..%{_javadir}/%{name}.jar .)
    (cd $RPM_BUILD_ROOT%{tomcat3appsdir}/%{name}-$webapp/WEB-INF \
    && for tld in ../../../../..%{_datadir}/%{name}/*.tld; do ln -sf $tld `basename $tld`; done)
done
# tomcat 4 webapps
install -d -m 755 $RPM_BUILD_ROOT%{tomcat4appsdir}
for webapp in %{webapps}; do
    cp -pr target/$webapp $RPM_BUILD_ROOT%{tomcat4appsdir}/%{name}-$webapp
    (cd $RPM_BUILD_ROOT%{tomcat4appsdir}/%{name}-$webapp/WEB-INF/lib \
    && ln -sf ../../../../../..%{_javadir}/%{name}.jar .)
    (cd $RPM_BUILD_ROOT%{tomcat4appsdir}/%{name}-$webapp/WEB-INF \
    && for tld in ../../../../..%{_datadir}/%{name}/*.tld; do ln -sf $tld `basename $tld`; done)
done

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc INSTALL LICENSE README WhoWeAre
%{_javadir}/*
%{_datadir}/%{name}

%files manual
%defattr(-,root,root)
%doc target/documentation/*.html
%doc target/documentation/*.gif
%doc target/documentation/uml
%doc target/documentation/userGuide
%doc target/documentation/images

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/%{name}-%{version}

%files webapps-tomcat3
%defattr(-,tomcat3,tomcat3)
%dir %{tomcat3appsdir}/%{name}-blank
%dir %{tomcat3appsdir}/%{name}-blank/WEB-INF
%config(noreplace) %{tomcat3appsdir}/%{name}-blank/WEB-INF/web.xml
%config(noreplace) %{tomcat3appsdir}/%{name}-blank/WEB-INF/struts-config.xml
%{tomcat3appsdir}/%{name}-blank/WEB-INF/lib
%config(noreplace) %{tomcat3appsdir}/%{name}-blank/WEB-INF/classes/*.properties
%{tomcat3appsdir}/%{name}-blank/WEB-INF/*.tld
%{tomcat3appsdir}/%{name}-blank/*.jsp
%dir %{tomcat3appsdir}/%{name}-upload
%dir %{tomcat3appsdir}/%{name}-upload/WEB-INF
%config(noreplace) %{tomcat3appsdir}/%{name}-upload/WEB-INF/web.xml
%config(noreplace) %{tomcat3appsdir}/%{name}-upload/WEB-INF/struts-config.xml
%{tomcat3appsdir}/%{name}-upload/WEB-INF/lib
%{tomcat3appsdir}/%{name}-upload/WEB-INF/*.tld
%{tomcat3appsdir}/%{name}-upload/*.jsp
%dir %{tomcat3appsdir}/%{name}-example
%dir %{tomcat3appsdir}/%{name}-example/WEB-INF
%config(noreplace) %{tomcat3appsdir}/%{name}-example/WEB-INF/web.xml
%config(noreplace) %{tomcat3appsdir}/%{name}-example/WEB-INF/struts-config.xml
%config(noreplace) %{tomcat3appsdir}/%{name}-example/WEB-INF/database.xml
%config(noreplace) %{tomcat3appsdir}/%{name}-example/WEB-INF/action.xml
%{tomcat3appsdir}/%{name}-example/WEB-INF/lib
%{tomcat3appsdir}/%{name}-example/WEB-INF/*.tld
%{tomcat3appsdir}/%{name}-example/*.jsp
%{tomcat3appsdir}/%{name}-example/*.htm
%{tomcat3appsdir}/%{name}-example/*.gif
%dir %{tomcat3appsdir}/%{name}-template-example
%dir %{tomcat3appsdir}/%{name}-template-example/WEB-INF
%config(noreplace) %{tomcat3appsdir}/%{name}-template-example/WEB-INF/web.xml
%config(noreplace) %{tomcat3appsdir}/%{name}-template-example/WEB-INF/struts-config.xml
%{tomcat3appsdir}/%{name}-template-example/WEB-INF/lib
%{tomcat3appsdir}/%{name}-template-example/WEB-INF/*.tld
%{tomcat3appsdir}/%{name}-template-example/graphics
%{tomcat3appsdir}/%{name}-template-example/css
%{tomcat3appsdir}/%{name}-template-example/*.jsp
%{tomcat3appsdir}/%{name}-template-example/*.html
%dir %{tomcat3appsdir}/%{name}-exercise-taglib
%dir %{tomcat3appsdir}/%{name}-exercise-taglib/WEB-INF
%config(noreplace) %{tomcat3appsdir}/%{name}-exercise-taglib/WEB-INF/web.xml
%config(noreplace) %{tomcat3appsdir}/%{name}-exercise-taglib/WEB-INF/struts-config.xml
%{tomcat3appsdir}/%{name}-exercise-taglib/WEB-INF/lib
%{tomcat3appsdir}/%{name}-exercise-taglib/WEB-INF/*.tld
%{tomcat3appsdir}/%{name}-exercise-taglib/*.jsp

%files webapps-tomcat4
%defattr(-,tomcat4,tomcat4)
%dir %{tomcat4appsdir}/%{name}-blank
%dir %{tomcat4appsdir}/%{name}-blank/WEB-INF
%config(noreplace) %{tomcat4appsdir}/%{name}-blank/WEB-INF/web.xml
%config(noreplace) %{tomcat4appsdir}/%{name}-blank/WEB-INF/struts-config.xml
%{tomcat4appsdir}/%{name}-blank/WEB-INF/lib
%config(noreplace) %{tomcat4appsdir}/%{name}-blank/WEB-INF/classes/*.properties
%{tomcat4appsdir}/%{name}-blank/WEB-INF/*.tld
%{tomcat4appsdir}/%{name}-blank/*.jsp
%dir %{tomcat4appsdir}/%{name}-upload
%dir %{tomcat4appsdir}/%{name}-upload/WEB-INF
%config(noreplace) %{tomcat4appsdir}/%{name}-upload/WEB-INF/web.xml
%config(noreplace) %{tomcat4appsdir}/%{name}-upload/WEB-INF/struts-config.xml
%{tomcat4appsdir}/%{name}-upload/WEB-INF/lib
%{tomcat4appsdir}/%{name}-upload/WEB-INF/*.tld
%{tomcat4appsdir}/%{name}-upload/*.jsp
%dir %{tomcat4appsdir}/%{name}-example
%dir %{tomcat4appsdir}/%{name}-example/WEB-INF
%config(noreplace) %{tomcat4appsdir}/%{name}-example/WEB-INF/web.xml
%config(noreplace) %{tomcat4appsdir}/%{name}-example/WEB-INF/struts-config.xml
%config(noreplace) %{tomcat4appsdir}/%{name}-example/WEB-INF/database.xml
%config(noreplace) %{tomcat4appsdir}/%{name}-example/WEB-INF/action.xml
%{tomcat4appsdir}/%{name}-example/WEB-INF/lib
%{tomcat4appsdir}/%{name}-example/WEB-INF/*.tld
%{tomcat4appsdir}/%{name}-example/*.jsp
%{tomcat4appsdir}/%{name}-example/*.htm
%{tomcat4appsdir}/%{name}-example/*.gif
%dir %{tomcat4appsdir}/%{name}-template-example
%dir %{tomcat4appsdir}/%{name}-template-example/WEB-INF
%config(noreplace) %{tomcat4appsdir}/%{name}-template-example/WEB-INF/web.xml
%config(noreplace) %{tomcat4appsdir}/%{name}-template-example/WEB-INF/struts-config.xml
%{tomcat4appsdir}/%{name}-template-example/WEB-INF/lib
%{tomcat4appsdir}/%{name}-template-example/WEB-INF/*.tld
%{tomcat4appsdir}/%{name}-template-example/graphics
%{tomcat4appsdir}/%{name}-template-example/css
%{tomcat4appsdir}/%{name}-template-example/*.jsp
%{tomcat4appsdir}/%{name}-template-example/*.html
%dir %{tomcat4appsdir}/%{name}-exercise-taglib
%dir %{tomcat4appsdir}/%{name}-exercise-taglib/WEB-INF
%config(noreplace) %{tomcat4appsdir}/%{name}-exercise-taglib/WEB-INF/web.xml
%config(noreplace) %{tomcat4appsdir}/%{name}-exercise-taglib/WEB-INF/struts-config.xml
%{tomcat4appsdir}/%{name}-exercise-taglib/WEB-INF/lib
%{tomcat4appsdir}/%{name}-exercise-taglib/WEB-INF/*.tld
%{tomcat4appsdir}/%{name}-exercise-taglib/*.jsp

%changelog
* Tue Mar 25 2003 Nicolas Mailhot <Nicolas.Mailhot (at) JPackage.org> 1.0.2-4jpp
- for jpackage-utils 1.5

* Thu Mar 28 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0.2-3jpp 
- fixed incorrect files in manual package

* Wed Mar 27 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0.2-2jpp 
- corrected URL
- cleaned webapps
- tagged webapps

* Sun Mar 24 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0.2-1jpp 
- 1.0.2
- generic servlet support
- distinct webapps for tomcat3 and tomcat4
- no duplicate files for webapps
- correct file ownership for webapps

* Wed Jan 23 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-4jpp
- section macro
- versioned dir for javadoc
- no dependencies for manual and javadoc packages
- stricter dependencies for webapp package
- requires tomcat3
- no more requires servlet3 as tomcat3 requires it
- requires and buildrequires xalan-j2 >= 2.2.0
- adaptation to new servlet3 package
- adaptation to new xalan-j2 package
- adapation to new tomcat3 package
- uncompressed webapps

* Wed Dec 5 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-3jpp
- javadoc into javadoc package

* Tue Nov 20 2001 Christian Zoffoli <czoffoli@littlepenguin.org> 1.0-2jpp
- removed packager tag
- new jpp extension
- added xalan 2.2.D13 support

* Thu Nov 1 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-1jpp
- first JPackage release
